/* Exercise 10.14 */
/* This program inputs a packed (unsigned) integer */
/* and unpack it as two characters */
/* and then prints them as binary */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>


void DecToBin(unsigned int *, char *);
void leadingZero(char *, int);
void unpackCharacters(unsigned int *, char *, char *);


main()
{
   unsigned int tmpInt;
   char binStr[sizeof(int) * 8 + 1];
   char char1, char2;

   clrscr();

   printf("\n Enter the packed (unsiged) integer: ");
   scanf("%u", &tmpInt);

   DecToBin(&tmpInt, binStr);
   leadingZero(binStr, 16);
   printf("\n\n\n Packed unsigned integer in binary      : %s", binStr);

   unpackCharacters(&tmpInt, &char1, &char2);

   tmpInt = (unsigned) char1;
   DecToBin(&tmpInt, binStr);
   leadingZero(binStr, 8);
   printf("\n\n Unpacked first  character \"%c\" in binary: %s........  (Dec: %u)", char1, binStr, char1);

   tmpInt = (unsigned) char2;
   DecToBin(&tmpInt, binStr);
   leadingZero(binStr, 8);
   printf("\n\n Unpacked second character \"%c\" in binary: ........%s  (Dec: %u)", char2, binStr, char2);

   return 0;
}



void DecToBin(unsigned int *decValue, char *tmpStr)
{
   unsigned int number;
   int indx = 0;

   number = *decValue;
   tmpStr[0] = '\0';

   while (number >= 2)
   {
      tmpStr[indx] = (number % 2) + 48;
      indx++;
      number /= 2;
   }

   tmpStr[indx] = number + 48;
   tmpStr[indx + 1] = '\0';

   strrev(tmpStr);

   return;
}


void leadingZero(char *targetStr, int strSize)
{
   char *tmpStr;
   int cnt;

   if (strlen(targetStr) >= strSize) return;

   /* allocate memory for string */
   if ((tmpStr = (char *) malloc(strSize + 1)) == NULL)
   {
      printf("Not enough memory to allocate buffer\n");
      exit(1);  /* terminate program if out of memory */
   }

   for (cnt = 0 ; cnt <= (strSize - strlen(targetStr) - 1) ; cnt++)
      tmpStr[cnt] = '0';

   tmpStr[strSize - strlen(targetStr)] = '\0';

   strcat(tmpStr, targetStr);
   strcpy(targetStr, tmpStr);

   /* free memory */
   free(tmpStr);

   return;
}


void unpackCharacters(unsigned int *packedInt, char *ch1, char *ch2)
{
   *ch1 = (char) ((*packedInt & 0xFF00) >> 8);
   *ch2 = (char) (*packedInt & 0x00FF);

   return;
}
