/* Exercise 10.13 */
/* This program inputs two characters and pack them into an unsigned */
/* integer and then prints them as binary */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>


void DecToBin(unsigned int *, char *);
void leadingZero(char *, int);
unsigned int packCharacters(char *, char *);


main()
{
   unsigned int tmpInt;
   char binStr[sizeof(int) * 8 + 1];
   char char1, char2;

   clrscr();

   printf("\n Enter 1. character to be packed: ");
   char1 = getche();

   printf("\n Enter 2. character to be packed: ");
   char2 = getche();

   tmpInt = char1;
   DecToBin(&tmpInt, binStr);
   leadingZero(binStr, 8);
   printf("\n\n\n First character in binary : %s........    (Dec: %u)",
	   binStr, char1);

   tmpInt = char2;
   DecToBin(&tmpInt, binStr);
   leadingZero(binStr, 8);
   printf("\n\n Second character in binary: ........%s    (Dec: %u)",
	   binStr, char2);

   tmpInt = packCharacters(&char1, &char2);

   DecToBin(&tmpInt, binStr);
   leadingZero(binStr, 16);
   printf("\n\n Packed integer in binary  : %s    (Dec: %u)\n\n\n",
	   binStr, tmpInt);

   return 0;
}



void DecToBin(unsigned int *decValue, char *tmpStr)
{
   unsigned int number;
   int indx = 0;

   number = *decValue;
   tmpStr[0] = '\0';

   while (number >= 2)
   {
      tmpStr[indx] = (number % 2) + 48;
      indx++;
      number /= 2;
   }

   tmpStr[indx] = number + 48;
   tmpStr[indx + 1] = '\0';

   strrev(tmpStr);

   return;
}


void leadingZero(char *targetStr, int strSize)
{
   char *tmpStr;
   int cnt;

   if (strlen(targetStr) >= strSize) return;

   /* allocate memory for string */
   if ((tmpStr = (char *) malloc(strSize + 1)) == NULL)
   {
      printf("Not enough memory to allocate buffer\n");
      exit(1);  /* terminate program if out of memory */
   }

   for (cnt = 0 ; cnt <= (strSize - strlen(targetStr) - 1) ; cnt++)
      tmpStr[cnt] = '0';

   tmpStr[strSize - strlen(targetStr)] = '\0';

   strcat(tmpStr, targetStr);
   strcpy(targetStr, tmpStr);

   /* free memory */
   free(tmpStr);

   return;
}


unsigned int packCharacters(char *ch1, char *ch2)
{
   unsigned int tmpInt;

   tmpInt = *ch1;
   tmpInt <<= 8;
   tmpInt = (tmpInt | *ch2);
   return tmpInt;
}
